/* massware.c */
/* warning: this file is automatically generated, please do not modify it */
/* author: Shengpu Liu */

#include <sys_module.h>
#include <led_dbg.h>
#include "massware.h"

#define NEIGHBERRING_MOD_ID     (DFLT_APP_ID3)
#define NEIGHBERRING_SET_BEACON_FREQ     (MOD_MSG_START + 105)
#define NEIGHBERRING_START_MEASURING     (MOD_MSG_START + 107)
#define NEIGHBERRING_GET_NEIGHBOR_NUM     (MOD_MSG_START + 106)
#define LSW_TRANSFORM_MOD_ID     (APP_MOD_MIN_PID + 44)
#define LSWT_MSG_SET_SCALE     (MOD_MSG_START + 102)
#define LSWT_MSG_INVERSE_OUTPUT     (MOD_MSG_START + 104)
#define LSWT_MSG_FORWARD_OUTPUT     (MOD_MSG_START + 101)
#define LSWT_MSG_INVERSE_INPUT     (MOD_MSG_START + 103)
#define LSWT_MSG_FORWARD_INPUT     (MOD_MSG_START + 100)
#define SENSOR_READING_MOD_ID     (APP_MOD_MIN_PID + 48)
#define SENSOR_MSG_SET_SAMPEL_FREQ     (MOD_MSG_START + 103)
#define SENSOR_MSG_SET_DATA_LENGTH     (MOD_MSG_START + 102)
#define SENSOR_MSG_START_SAMPLE     (MOD_MSG_START + 100)
#define SENSOR_MSG_OUTPUT_DATA     (MOD_MSG_START + 101)
#define SCALE_QUANTIZATION_MOD_ID     (APP_MOD_MIN_PID + 45)
#define QUAN_MSG_INVERSE_INPUT     (MOD_MSG_START + 102)
#define QUAN_MSG_FORWARD_INPUT     (MOD_MSG_START + 100)
#define QUAN_MSG_FORWARD_OUTPUT     (MOD_MSG_START + 101)
#define QUAN_MSG_INVERSE_OUTPUT     (MOD_MSG_START + 103)
#define DISTRIBUTED_SOURCE_CODING_MOD_ID     (APP_MOD_MIN_PID + 46)
#define DSC_MSG_SET_CORRELATION     (MOD_MSG_START + 102)
#define DSC_MSG_FORWARD_OUTPUT     (MOD_MSG_START + 101)
#define DSC_MSG_FORWARD_INPUT     (MOD_MSG_START + 100)
#define DSC_MSG_INVERSE_OUTPUT     (MOD_MSG_START + 104)
#define DSC_MSG_INVERSE_INPUT     (MOD_MSG_START + 103)
#define UNARY_CODING_MOD_ID     (APP_MOD_MIN_PID + 47)
#define UNARY_MSG_INVERSE_OUTPUT     (MOD_MSG_START + 104)
#define UNARY_MSG_INVERSE_INPUT     (MOD_MSG_START + 103)
#define UNARY_MSG_FORWARD_INPUT     (MOD_MSG_START + 100)
#define UNARY_MSG_FORWARD_OUTPUT     (MOD_MSG_START + 101)
#define MASS_MSG_NEIGHBERRING_GET_NEIGHBOR_NUM     (MOD_MSG_START + 50)

#define SYNC_TIMER_INTERVAL	  512L // 
#define SYNC_REQUEST_TID      0

typedef struct {
  uint8_t pid;
  uint8_t state;
  uint8_t activeIdx;
  uint32_t MASS_VAR_NEIGHBERRING_GET_NEIGHBOR_NUM;
  uint16_t dest_addr;
  uint16_t sync_pkt_len;
  uint8_t* sync_pkt;
} app_state_t;

static int8_t massware_msg_handler(void *start, Message *e);

static const mod_header_t mod_header SOS_MODULE_HEADER = {
  .mod_id         = MASSWARE_AGENT_PID,
  .state_size     = sizeof(app_state_t),
  .num_sub_func   = 0,
  .num_prov_func  = 0,
  .platform_type  = HW_TYPE /* or PLATFORM_ANY */,
  .processor_type = MCU_TYPE,
  .code_id        = ehtons(MASSWARE_AGENT_PID),
  .module_handler = massware_msg_handler,
};

static int8_t massware_msg_handler(void *state, Message *msg)
{
  app_state_t *s = (app_state_t*)state;

  switch (msg->type){
  case MSG_INIT:
  {
    s->pid = msg->did;
    s->state = 0;
    s->activeIdx = 0;
    s->dest_addr = BCAST_ADDRESS;
    s->sync_pkt_len = 0;
    s->sync_pkt = NULL;
    s->MASS_VAR_NEIGHBERRING_GET_NEIGHBOR_NUM = 0;

    //set synchronization packet
    ParamSetting * paramList;
    ArchSetting * archList;

    s->sync_pkt_len += 1;  // for SyncRequest.act_num
    s->sync_pkt_len += 1;  // for ActuatorMeta.act_index
    s->sync_pkt_len += 1;  // for ActuatorMeta.param_num
    s->sync_pkt_len += 1;  // for ActuatorMeta.conn_num
    s->sync_pkt_len += (sizeof(ArchSetting) * 3);  // for ActuatorMeta.conn_list
    s->sync_pkt_len += 1;  // for ActuatorMeta.act_index
    s->sync_pkt_len += 1;  // for ActuatorMeta.param_num
    s->sync_pkt_len += 1;  // for ActuatorMeta.conn_num
    s->sync_pkt_len += (sizeof(ArchSetting) * 3);  // for ActuatorMeta.conn_list

    s->sync_pkt = (uint8_t*)sys_malloc(s->sync_pkt_len);
    if (NULL == s->sync_pkt) break;

    uint16_t len = 0;

    *(s->sync_pkt + len) = 2;
    len += 1;  // for SyncRequest.act_num

    *(s->sync_pkt + len) = 0;
    len += 1;  // for ActuatorMeta.act_index
    *(s->sync_pkt + len) = 0;
    len += 1;  // for ActuatorMeta.param_num
    *(s->sync_pkt + len) = 3;
    len += 1;  // for ActuatorMeta.conn_num
    archList = (ArchSetting *)(s->sync_pkt + len);
    archList[0].sender_pid = MASSWARE_AGENT_PID;
    archList[0].sender_msg_type = MASS_MSG_DATA_INPUT;
    archList[0].recver_pid = DISTRIBUTED_SOURCE_CODING_MOD_ID;
    archList[0].recver_msg_type = DSC_MSG_INVERSE_INPUT;
    archList[1].sender_pid = DISTRIBUTED_SOURCE_CODING_MOD_ID;
    archList[1].sender_msg_type = DSC_MSG_INVERSE_OUTPUT;
    archList[1].recver_pid = SCALE_QUANTIZATION_MOD_ID;
    archList[1].recver_msg_type = QUAN_MSG_INVERSE_INPUT;
    archList[2].sender_pid = SCALE_QUANTIZATION_MOD_ID;
    archList[2].sender_msg_type = QUAN_MSG_INVERSE_OUTPUT;
    archList[2].recver_pid = LSW_TRANSFORM_MOD_ID;
    archList[2].recver_msg_type = LSWT_MSG_INVERSE_INPUT;
    len += (sizeof(ArchSetting) * 3);  // for ActuatorMeta.param_list

    *(s->sync_pkt + len) = 1;
    len += 1;  // for ActuatorMeta.act_index
    *(s->sync_pkt + len) = 0;
    len += 1;  // for ActuatorMeta.param_num
    *(s->sync_pkt + len) = 3;
    len += 1;  // for ActuatorMeta.conn_num
    archList = (ArchSetting *)(s->sync_pkt + len);
    archList[0].sender_pid = MASSWARE_AGENT_PID;
    archList[0].sender_msg_type = MASS_MSG_DATA_INPUT;
    archList[0].recver_pid = UNARY_CODING_MOD_ID;
    archList[0].recver_msg_type = UNARY_MSG_INVERSE_INPUT;
    archList[1].sender_pid = UNARY_CODING_MOD_ID;
    archList[1].sender_msg_type = UNARY_MSG_INVERSE_OUTPUT;
    archList[1].recver_pid = SCALE_QUANTIZATION_MOD_ID;
    archList[1].recver_msg_type = QUAN_MSG_INVERSE_INPUT;
    archList[2].sender_pid = SCALE_QUANTIZATION_MOD_ID;
    archList[2].sender_msg_type = QUAN_MSG_INVERSE_OUTPUT;
    archList[2].recver_pid = LSW_TRANSFORM_MOD_ID;
    archList[2].recver_msg_type = LSWT_MSG_INVERSE_INPUT;
    len += (sizeof(ArchSetting) * 3);  // for ActuatorMeta.param_list

    if (len != s->sync_pkt_len) break;

    sys_post_net(MASSWARE_AGENT_PID, MASS_MSG_SYNC_REQUEST, s->sync_pkt_len, (void*)s->sync_pkt, SOS_MSG_RELEASE, s->dest_addr);
    sys_timer_start(SYNC_REQUEST_TID, SYNC_TIMER_INTERVAL, TIMER_ONE_SHOT);

    break;
  }
  case MSG_TIMER_TIMEOUT:
  {
    //set default parameters for all components
    sys_post_value(NEIGHBERRING_MOD_ID, NEIGHBERRING_SET_BEACON_FREQ, ehtonl((uint32_t)2048), 0);
    sys_post_value(LSW_TRANSFORM_MOD_ID, LSWT_MSG_SET_SCALE, ehtonl((uint32_t)2), 0);
    sys_post_value(SENSOR_READING_MOD_ID, SENSOR_MSG_SET_SAMPEL_FREQ, ehtonl((uint32_t)256), 0);
    sys_post_value(SENSOR_READING_MOD_ID, SENSOR_MSG_SET_DATA_LENGTH, ehtonl((uint32_t)16), 0);
    sys_post_value(DISTRIBUTED_SOURCE_CODING_MOD_ID, DSC_MSG_SET_CORRELATION, ehtonl((uint32_t)1), 0);

    uint8_t msg_size = sizeof(PostDestMsg);
    PostDestMsg* pdmsg;

    //set default (the first rule) connections
    pdmsg = (PostDestMsg*)sys_malloc(msg_size);
    pdmsg->dst_mod_id = LSW_TRANSFORM_MOD_ID;
    pdmsg->msg_type = LSWT_MSG_FORWARD_INPUT;
    sys_post(SENSOR_READING_MOD_ID, SENSOR_MSG_OUTPUT_DATA, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

    pdmsg = (PostDestMsg*)sys_malloc(msg_size);
    pdmsg->dst_mod_id = SCALE_QUANTIZATION_MOD_ID;
    pdmsg->msg_type = QUAN_MSG_FORWARD_INPUT;
    sys_post(LSW_TRANSFORM_MOD_ID, LSWT_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

    pdmsg = (PostDestMsg*)sys_malloc(msg_size);
    pdmsg->dst_mod_id = DISTRIBUTED_SOURCE_CODING_MOD_ID;
    pdmsg->msg_type = DSC_MSG_FORWARD_INPUT;
    sys_post(SCALE_QUANTIZATION_MOD_ID, QUAN_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

    pdmsg = (PostDestMsg*)sys_malloc(msg_size);
    pdmsg->dst_mod_id = MASSWARE_AGENT_PID;
    pdmsg->msg_type = MASS_MSG_DATA_OUTPUT;
    sys_post(DISTRIBUTED_SOURCE_CODING_MOD_ID, DSC_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

    s->dest_addr = BCAST_ADDRESS;

    //subscribe to measurement tools
    pdmsg = (PostDestMsg*)sys_malloc(msg_size);
    pdmsg->dst_mod_id = MASSWARE_AGENT_PID;
    pdmsg->msg_type = MASS_MSG_NEIGHBERRING_GET_NEIGHBOR_NUM;
    sys_post(NEIGHBERRING_MOD_ID, NEIGHBERRING_GET_NEIGHBOR_NUM, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

    //start measurement tools and application
    sys_post_value(NEIGHBERRING_MOD_ID, NEIGHBERRING_START_MEASURING, 0x00ffff00, 0);
    sys_post_value(SENSOR_READING_MOD_ID, SENSOR_MSG_START_SAMPLE, 0x00ffff00, 0);
    break;
  }
  case MASS_MSG_NEIGHBERRING_GET_NEIGHBOR_NUM:
  {
    uint8_t msg_size = sizeof(PostDestMsg);
    PostDestMsg* pdmsg;

    s->MASS_VAR_NEIGHBERRING_GET_NEIGHBOR_NUM = ehtonl(*((uint32_t*)(msg->data)));
    if ((s->MASS_VAR_NEIGHBERRING_GET_NEIGHBOR_NUM*2) >= (1*2)) {
      if (0 == s->activeIdx) return SOS_OK;
      s->activeIdx = 0;

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = LSW_TRANSFORM_MOD_ID;
      pdmsg->msg_type = LSWT_MSG_FORWARD_INPUT;
      sys_post(SENSOR_READING_MOD_ID, SENSOR_MSG_OUTPUT_DATA, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = SCALE_QUANTIZATION_MOD_ID;
      pdmsg->msg_type = QUAN_MSG_FORWARD_INPUT;
      sys_post(LSW_TRANSFORM_MOD_ID, LSWT_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = DISTRIBUTED_SOURCE_CODING_MOD_ID;
      pdmsg->msg_type = DSC_MSG_FORWARD_INPUT;
      sys_post(SCALE_QUANTIZATION_MOD_ID, QUAN_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = MASSWARE_AGENT_PID;
      pdmsg->msg_type = MASS_MSG_DATA_OUTPUT;
      sys_post(DISTRIBUTED_SOURCE_CODING_MOD_ID, DSC_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      s->dest_addr = BCAST_ADDRESS;
    }
    else if ((s->MASS_VAR_NEIGHBERRING_GET_NEIGHBOR_NUM*2) < (1*2)) {
      if (1 == s->activeIdx) return SOS_OK;
      s->activeIdx = 1;

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = LSW_TRANSFORM_MOD_ID;
      pdmsg->msg_type = LSWT_MSG_FORWARD_INPUT;
      sys_post(SENSOR_READING_MOD_ID, SENSOR_MSG_OUTPUT_DATA, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = SCALE_QUANTIZATION_MOD_ID;
      pdmsg->msg_type = QUAN_MSG_FORWARD_INPUT;
      sys_post(LSW_TRANSFORM_MOD_ID, LSWT_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = UNARY_CODING_MOD_ID;
      pdmsg->msg_type = UNARY_MSG_FORWARD_INPUT;
      sys_post(SCALE_QUANTIZATION_MOD_ID, QUAN_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      pdmsg = (PostDestMsg*)sys_malloc(msg_size);
      pdmsg->dst_mod_id = MASSWARE_AGENT_PID;
      pdmsg->msg_type = MASS_MSG_DATA_OUTPUT;
      sys_post(UNARY_CODING_MOD_ID, UNARY_MSG_FORWARD_OUTPUT, msg_size, (void*)pdmsg, SOS_MSG_RELEASE);

      s->dest_addr = BCAST_ADDRESS;
    }
    break;
  }
  case MASS_MSG_DATA_OUTPUT: 
  {
    uint16_t i, len = msg->len;
    uint8_t* data = (uint8_t*)(msg->data);
    uint8_t* pkt = (uint8_t*)sys_malloc(len + 1);
    *pkt = s->activeIdx;
    for (i = 0; i < len; i++)
      pkt[i + 1] = data[i];

    sys_post_net(MASSWARE_AGENT_PID, MASS_MSG_DATA_INPUT, len + 1, (void*)pkt, SOS_MSG_RELEASE, s->dest_addr);
    break;
  }
  case MASS_MSG_DATA_INPUT: 
  {
    // if this id is based station, send to upper application
    // otherwise forward it to the next hop
    uint16_t my_id = sys_id();
    if (my_id == msg->daddr) {
      // send to upper app
    }
    else {
      // forward it
    }
    break;
  }
  case MASS_MSG_SYNC_REQUEST: 
  {
    uint16_t my_id = sys_id();
    if (my_id == msg->daddr) {
      // send to upper app
    }
    else {
      // forward it
    }
    break;
  }
  case MASS_MSG_SYNC_REPLY: 
  {
    // used to confirm that the based station received my sync request message
    break;
  }
  case MASS_MSG_SYNC_REASK: 
  {
    // check the original sender's address
    s->dest_addr = msg->saddr;
    if (s->sync_pkt_len > 0 && s->sync_pkt != NULL)
      sys_post_net(MASSWARE_AGENT_PID, MASS_MSG_SYNC_REQUEST, s->sync_pkt_len, (void*)s->sync_pkt, SOS_MSG_RELEASE, s->dest_addr);
    break;
  }
  case MASS_MSG_SET_DESTINATION: 
  {
    s->dest_addr = ehtons(*(uint16_t*)(msg->data));
    break;
  }
  case MSG_FINAL: 
  {
    if (s->sync_pkt_len > 0 && s->sync_pkt != NULL) {
      sys_free(s->sync_pkt);
      s->sync_pkt_len = 0;
      s->sync_pkt = NULL;
    }
    break;
  }
  default: return -EINVAL;
  }
  return SOS_OK;
}

#ifndef _MODULE_
mod_header_ptr massware_get_header()
{
  return sos_get_header_address(mod_header);
}
#endif
